/*************************************************************************
***     Authentication, authorization, accounting + firewalling package
***     (c) 1998-2003 Anton Vinokurov <anton@netams.com>
***		(c) 2003 NeTAMS Development Team
***		All rights reserved. See 'Copying' file included in distribution
***		For latest version and more info, visit this project web page
***		located at http://www.netams.com
***		 					
*************************************************************************/
/* $Id: st_any.h,v 1.8 2003/04/12 11:27:37 anton Exp $ */

#ifdef USE_MYSQL
#ifdef LINUX
#include <mysql.h>
#endif
#ifdef FREEBSD
#include <mysql/mysql.h>
#endif
#endif

#ifdef USE_POSTGRES
#include <libpq-fe.h>
#define MONITOR_COMMIT_NUM 100 // number of inserts to be commited
#endif

//////////////////////////////////////////////////////////////////////////
void stOpenHash(Service *s);
void stSaveHash(Service *s, Message *msg);
void stLoadHash(Service *s, Message *msg);
void stSyncHash(Service *s);
void stCloseHash(Service *s);


void stOpenSql(Service *s);
void stSaveSql(Service *s, Message *msg);
void stLoadSql(Service *s, Message *msg);
void stStatSql(Service *s, Message *msg);
unsigned stSyncSql(Service *s);
void stCloseSql(Service *s);
void stMonitorToSql(Service *s, time_t t, unsigned msec, NetUnit *u, struct ip *ip);

#ifdef USE_MYSQL
void my_stOpenSql(Service *s);
void my_stSaveSql(Service *s, Message *msg);
void my_stLoadSql(Service *s, Message *msg);
void my_stStatSql(Service *s, Message *msg);
unsigned my_stSyncSql(Service *s);
void my_stCloseSql(Service *s);
void my_stMonitorToSql(Service *s, time_t t, unsigned msec, NetUnit *u, struct ip *ip);
void my_stStatSql_p(stat_data *s, char prefix, MYSQL *m, int i, oid u, oid p, unsigned points);
#endif

#ifdef USE_POSTGRES
void pg_stOpenSql(Service *s);
void pg_stSaveSql(Service *s, Message *msg);
void pg_stLoadSql(Service *s, Message *msg);
void pg_stStatSql(Service *s, Message *msg);
unsigned pg_stSyncSql(Service *s);
void pg_stCloseSql(Service *s);
void pg_stMonitorToSql(Service *s, time_t t, unsigned msec, NetUnit *u, struct ip *ip);
void pg_stStatSql_p(stat_data *s, char prefix, PGconn *conn, int i, oid u, oid p, unsigned points);
#endif

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
