/*************************************************************************
***     Authentication, authorization, accounting + firewalling package
***     (c) 1998-2003 Anton Vinokurov <anton@netams.com>
***		(c) 2003 NeTAMS Development Team
***		All rights reserved. See 'Copying' file included in distribution
***		For latest version and more info, visit this project web page
***		located at http://www.netams.com
***		 					
*************************************************************************/
/* $Id: st_sql.c,v 1.8 2003/02/27 17:26:53 anton Exp $ */

#include "netams.h"

//////////////////////////////////////////////////////////////////////////
void stOpenSql(Service *s){
        ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	
	switch (cfg->type) {
#ifdef USE_MYSQL
		case MY_SQL:
			my_stOpenSql(s);
			break;
#endif
#ifdef USE_POSTGRES
		case POSTGRES:
			pg_stOpenSql(s);
			break;
#endif
		case UNKNOWN:
		default:
			aLog(D_ERR, "SQL feature is not compiled in!\n");
			break;
	}
}

//////////////////////////////////////////////////////////////////////////
void stCloseSql(Service *s){
        ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

        switch (cfg->type) {
#ifdef USE_MYSQL
                case MY_SQL:
                        my_stCloseSql(s);
                        break;
#endif
#ifdef USE_POSTGRES
                case POSTGRES:
                        pg_stCloseSql(s);
                        break;
#endif
                case UNKNOWN:
                default:
                        aLog(D_ERR, "SQL feature is not compiled in!\n");
                        break;
        }
}

//////////////////////////////////////////////////////////////////////////
void stSaveSql(Service *s, Message *msg){
        ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

        switch (cfg->type) {
#ifdef USE_MYSQL
                case MY_SQL:
                        my_stSaveSql(s,msg);
                        break;
#endif
#ifdef USE_POSTGRES
                case POSTGRES:
                        pg_stSaveSql(s,msg);
                        break;
#endif
                case UNKNOWN:
                default:
                        aLog(D_ERR, "SQL feature is not compiled in!\n");
                        break;
        }
}
//////////////////////////////////////////////////////////////////////////
void stLoadSql(Service *s, Message *msg){
        ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

        switch (cfg->type) {
#ifdef USE_MYSQL
                case MY_SQL:
                        my_stLoadSql(s,msg);
                        break;
#endif
#ifdef USE_POSTGRES
                case POSTGRES:
                        pg_stLoadSql(s,msg);
                        break;
#endif
                case UNKNOWN:
                default:
                        aLog(D_ERR, "SQL feature is not compiled in!\n");
                        break;
        }
}

//////////////////////////////////////////////////////////////////////////
void stStatSql(Service *s, Message *msg){
        ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

        switch (cfg->type) {
#ifdef USE_MYSQL
                case MY_SQL:
                        my_stStatSql(s,msg);
                        break;
#endif
#ifdef USE_POSTGRES
                case POSTGRES:
                        pg_stStatSql(s,msg);
                        break;
#endif
                case UNKNOWN:
                default:
                        aLog(D_ERR, "SQL feature is not compiled in!\n");
                        break;
        }
}

//////////////////////////////////////////////////////////////////////////
unsigned stSyncSql(Service *s){
        ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	unsigned sync=0;

	switch (cfg->type) {
#ifdef USE_MYSQL
                case MY_SQL:
                        sync = my_stSyncSql(s);
                        break;
#endif
#ifdef USE_POSTGRES
                case POSTGRES:
                        sync = pg_stSyncSql(s);
                        break;
#endif
                case UNKNOWN:
                default:
                        aLog(D_ERR, "SQL feature is not compiled in!\n");
                        break;
        }

	return sync;
}

//////////////////////////////////////////////////////////////////////////
void stMonitorToSql(Service *s, time_t t, unsigned msec, NetUnit *u, struct ip *ip){
        ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

	if(!cfg->fd3) return; 	
       
 	switch (cfg->type) {
#ifdef USE_MYSQL
                case MY_SQL:
                        my_stMonitorToSql(s,t,msec,u,ip);
                        break;
#endif
#ifdef USE_POSTGRES
                case POSTGRES:
                        pg_stMonitorToSql(s,t,msec,u,ip);
                        break;
#endif
                case UNKNOWN:
                default:
                        aLog(D_ERR, "SQL feature is not compiled in!\n");
                        break;
        }
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
