/*************************************************************************
***     Authentication, authorization, accounting + firewalling package
***     (c) 1998-2003 Anton Vinokurov <anton@netams.com>
***		(c) 2003 NeTAMS Development Team
***		All rights reserved. See 'Copying' file included in distribution
***		For latest version and more info, visit this project web page
***		located at http://www.netams.com
***		 					
*************************************************************************/
/* $Id: st_sql_mysql.c,v 1.12 2003/04/24 14:39:35 jura Exp $ */

#ifdef USE_MYSQL

#include "netams.h"

//////////////////////////////////////////////////////////////////////////
void my_stOpenSql(Service *s){

	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

	MYSQL_RES *res;
	char *my_host, *my_user, *my_pass, *my_dbname;
	
	char buffer[255]; 

 	(MYSQL*)cfg->fd1=mysql_init((MYSQL*)cfg->fd1); 
 	(MYSQL*)cfg->fd2=mysql_init((MYSQL*)cfg->fd2); 

	if(!(cfg->fd1 && cfg->fd2)) {
		aLog(D_CRIT, "mysql init failed	\n");
		return;
	}

	mysql_options((MYSQL*)cfg->fd1, MYSQL_OPT_CONNECT_TIMEOUT, "2");
	mysql_options((MYSQL*)cfg->fd2, MYSQL_OPT_CONNECT_TIMEOUT, "2");
	
	if (!cfg->hostname) my_host="localhost"; else my_host=cfg->hostname;
	if (!cfg->username) my_user="root"; else my_user=cfg->username;
	if (!cfg->password) my_pass=""; else my_pass=cfg->password;
	if (!cfg->dbname) my_dbname="netams"; else my_dbname=cfg->dbname;

	if (!mysql_real_connect((MYSQL*)cfg->fd1, my_host, my_user, my_pass, NULL, 3306,NULL,0)) {
		aLog(D_WARN, "mysql connect failed: %s, continuing closed\n", mysql_error((MYSQL*)cfg->fd1));
		return;
	}

	if (!mysql_real_connect((MYSQL*)cfg->fd2, my_host, my_user, my_pass, NULL, 3306,NULL,0)) {
		aLog(D_WARN, "mysql connect failed: %s, continuing closed\n", mysql_error((MYSQL*)cfg->fd2));
		return;
	}

	res=mysql_list_dbs((MYSQL*)cfg->fd1, my_dbname); 
	if (!res) {
		aLog(D_ERR, "mysql list dbs failed: %s\n", mysql_error((MYSQL*)cfg->fd1)); 
		return;
	}

	if (!mysql_num_rows(res)) { //hmmm, there are no netams database there... creating everything...
		snprintf(buffer, 254, "CREATE DATABASE %s", my_dbname);
		if (mysql_query((MYSQL*)cfg->fd1, buffer)) aLog(D_ERR, "mysql create db failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
		snprintf(buffer, 254, "USE %s", my_dbname);
		if (mysql_query((MYSQL*)cfg->fd1, buffer)) aLog(D_ERR, "mysql use db failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
		if (mysql_query((MYSQL*)cfg->fd1, "CREATE TABLE raw (unit_oid INT UNSIGNED NOT NULL, policy_oid INT UNSIGNED NOT NULL, t_from INT UNSIGNED, t_to INT UNSIGNED, bytes_in BIGINT UNSIGNED, bytes_out BIGINT UNSIGNED, KEY (unit_oid), KEY (policy_oid));\0")) aLog(D_ERR, "mysql create raw failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
		if (mysql_query((MYSQL*)cfg->fd1, "CREATE TABLE summary (prefix ENUM('T','M','W','D','H') NOT NULL, unit_oid INT UNSIGNED NOT NULL, policy_oid INT UNSIGNED NOT NULL, t_from INT UNSIGNED NOT NULL, bytes_in BIGINT UNSIGNED, bytes_out BIGINT UNSIGNED, KEY (unit_oid), KEY (policy_oid),	KEY (t_from));\0")) aLog(D_ERR, "mysql create summary failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
		if (mysql_query((MYSQL*)cfg->fd1, "CREATE TABLE monitor (time TIMESTAMP NOT NULL , msec INT UNSIGNED, name VARCHAR(32), unit_oid INT UNSIGNED, proto TINYINT UNSIGNED, src INT UNSIGNED NOT NULL, srcport SMALLINT UNSIGNED, dst INT UNSIGNED NOT NULL, dstport SMALLINT UNSIGNED, len SMALLINT UNSIGNED, KEY(time));\0")) aLog(D_ERR, "mysql create monitor failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
		aLog(D_WARN, "mysql database [%s] created\n", my_dbname); 	
		}
	mysql_free_result(res);
	 
	if (mysql_select_db((MYSQL*)cfg->fd1, my_dbname)) aLog(D_ERR, "mysql select netams/raw failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
	if (mysql_select_db((MYSQL*)cfg->fd2, my_dbname)) aLog(D_ERR, "mysql select netams/summary failed: %s\n", mysql_error((MYSQL*)cfg->fd2));
	
	//if we monitor to database open connection for it
       	Service *ss=NULL;
        while((ss=Services.getServiceByName("monitor",ss))) {
                Monitor_cfg *Monitor=(Monitor_cfg*)ss->cfg;

                if(Monitor->storage_s == s) {
                        (MYSQL*)cfg->fd3=mysql_init((MYSQL*)cfg->fd3);
                        if(!cfg->fd3) {
                                aLog(D_CRIT, "mysql init failed \n");
                                return;
                        }
                        mysql_options((MYSQL*)cfg->fd3, MYSQL_OPT_CONNECT_TIMEOUT, "2");
                        if (!mysql_real_connect((MYSQL*)cfg->fd3, my_host, my_user, my_pass, NULL, 3306,NULL,0)) {
                        aLog(D_WARN, "mysql connect failed: %s, continuing closed\n", mysql_error((MYSQL*)cfg->fd3));
                        return;
                        }
                	if (mysql_select_db((MYSQL*)cfg->fd3, my_dbname)) aLog(D_ERR, "mysql select netams/monitor failed: %s\n", mysql_error((MYSQL*)cfg->fd3));
		        break;
                }
        }

	// hack for our client, Andy [03.11.2002]
	// we chould have auto-incremented ID and hostname in our RAW table
	// so first seek if that fields are already there and ALTER TABLE otherwise. 	
	mysql_query((MYSQL*)cfg->fd1, "SHOW columns from raw like 'hostname'");
	res=mysql_store_result((MYSQL*)cfg->fd1);
	 if (!res) {
                aLog(D_WARN, "mysql check for 'hostname' failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
                return;
        }
	if (!mysql_num_rows(res)) { // no such field there
		if (mysql_query((MYSQL*)cfg->fd1, "ALTER TABLE raw ADD id BIGINT UNSIGNED AUTO_INCREMENT PRIMARY KEY, ADD hostname VARCHAR(32) NULL")) aLog(D_WARN, "mysql alter raw failed: %s\n", mysql_error((MYSQL*)cfg->fd1));
		aLog(D_WARN, "mysql database [%s] altering table RAW\n", my_dbname); 	
		}
	// end of hack
	mysql_free_result(res);
			
	aLog(D_INFO, "MySQL DB:%d opened [%s]\n", s->instance, my_dbname);
}

//////////////////////////////////////////////////////////////////////////
void my_stCloseSql(Service *s){

	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	
	mysql_close((MYSQL*)cfg->fd1);
	mysql_close((MYSQL*)cfg->fd2);
	mysql_close((MYSQL*)cfg->fd3);
	aLog(D_INFO, "MySQL DB:%d closed\n", s->instance);

}

//////////////////////////////////////////////////////////////////////////
void my_stSaveSql(Service *s, Message *msg){

	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	char *query;
	query=(char *)aMalloc(255);
	int i;
	NetUnit *u;
	char *info;

	switch (msg->prefix){
		case 'F':
			u=Units.getUnitById(msg->netunit);
			snprintf(query, 254, "INSERT INTO raw VALUES (%d, %d, %ld, %ld, %qu, %qu, 0, '%s')", msg->netunit, msg->ap, msg->data.from, msg->data.to, msg->data.in, msg->data.out, u->name?u->name:"<??>");
			mysql_query((MYSQL*)cfg->fd1, query);
			i=mysql_affected_rows((MYSQL*)cfg->fd1);
			// aDebug(DEBUG_STORAGE, "%d %s\n", i, query); 
			aDebug(DEBUG_STORAGE, "SQL->HDD/raw(F) query %d bytes, affected: %d\n", strlen(query), i);
			break;

		case 'T':
		case 'M':
		case 'W':
		case 'D':
		case 'H':
			snprintf(query, 254, "UPDATE summary SET bytes_in=%qu, bytes_out=%qu WHERE (prefix='%c' AND unit_oid=%d AND policy_oid=%d AND t_from=%ld)", msg->data.in, msg->data.out, msg->prefix, msg->netunit, msg->ap, msg->data.from);
			mysql_query((MYSQL*)cfg->fd2, query);
			info=(char *)mysql_info((MYSQL*)cfg->fd2);
			if (info) { sscanf(info+14, "%d", &i); } else i=0;
			// aDebug(DEBUG_STORAGE, "%d %s\n", i, query); 
			if (i==0) { // update failed!
				snprintf(query, 254, "INSERT INTO summary VALUES ('%c', %d, %d, %ld, %qu, %qu)", msg->prefix, msg->netunit, msg->ap, msg->data.from, msg->data.in, msg->data.out);
				mysql_query((MYSQL*)cfg->fd2, query);
				i=mysql_affected_rows((MYSQL*)cfg->fd2);
				// aDebug(DEBUG_STORAGE, "%d %s\n", i, query); 
				}
			aDebug(DEBUG_STORAGE, "SQL->HDD/summary(%c) query %d bytes, affected: %d\n", msg->prefix, strlen(query), i);
			break;
		}

	aFree(query);

}
//////////////////////////////////////////////////////////////////////////
void my_stLoadSql(Service *s, Message *msg){

	msg->id=s->instance;
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	char *query;
	query=(char *)aMalloc(255);
	MYSQL_RES *res;
	MYSQL_ROW row;

	pstat *cps;
	MYSQL *m;
	
	if (msg->pdata)  // assuming type is READ, fill this unit policy data field on policy apply (startup)
		switch (msg->prefix){
			case 'T': cps=&(msg->pdata->t); break;
			case 'M': cps=&(msg->pdata->m); break;
			case 'W': cps=&(msg->pdata->w); break;
			case 'D': cps=&(msg->pdata->d); break;
			case 'H': cps=&(msg->pdata->h); break;
			case 'F': cps=&(msg->pdata->flow); break;
			}
	else cps=&(msg->data);	// pdata is NULL, reading a raw data while program is running

	if (msg->prefix=='F') {
			snprintf(query, 254, "SELECT bytes_in, bytes_out FROM raw WHERE unit_oid=%d AND policy_oid=%d AND t_from=%ld AND t_to=%ld", msg->netunit, msg->ap, cps->from, cps->to);
			m=(MYSQL*)cfg->fd1;
		} else if (msg->prefix=='T') {
			snprintf(query, 254, "SELECT bytes_in, bytes_out, t_from FROM summary WHERE prefix='T' AND unit_oid=%d AND policy_oid=%d", msg->netunit, msg->ap);
			m=(MYSQL*)cfg->fd2;
		} else {
			snprintf(query, 254, "SELECT bytes_in, bytes_out FROM summary WHERE prefix='%c' AND unit_oid=%d AND policy_oid=%d AND t_from=%ld", msg->prefix, msg->netunit, msg->ap, cps->from);
			m=(MYSQL*)cfg->fd2;
		}

	mysql_query(m, query);
	res=mysql_store_result(m); 
	if (res) {
		row=mysql_fetch_row(res);
		if (row) { 
			sscanf(row[0], "%qu", &cps->in); 
			sscanf(row[1], "%qu", &cps->out);
			if (msg->prefix=='T') sscanf(row[2], "%ld", &cps->from);
			}
		mysql_free_result(res);
		}
	aDebug(DEBUG_STORAGE, "SQL<-HDD/%c query %d bytes, fr=%ld in=%qu out=%qu\n", msg->prefix, strlen(query), cps->from, cps->in, cps->out);

	aFree(query);
					 
}

//////////////////////////////////////////////////////////////////////////
void my_stStatSql(Service *s, Message *msg){
	msg->id=s->instance;
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	MYSQL *m=(MYSQL*)cfg->fd2;

	policy_data *pd;
	NetUnit *u;
	int i;

	u=Units.getUnitById(msg->netunit);
	if (!u) return;

	msg->stat->num_policies=u->ap.num_policies;

	switch (msg->prefix){
		case 'W':
			msg->stat->num_points=24*7;
			break;
		case 'M':
			msg->stat->num_points=24*31;
			break;
		default:
			return;
		}

	msg->stat->in =(unsigned long long*)aMalloc((sizeof (unsigned long long))*msg->stat->num_points*msg->stat->num_policies);
	msg->stat->out=(unsigned long long*)aMalloc((sizeof (unsigned long long))*msg->stat->num_points*msg->stat->num_policies);
		
				
	for (pd=u->ap.root, i=0; pd!=NULL; pd=pd->next, i++) {
		my_stStatSql_p(msg->stat, msg->prefix, m, i, msg->netunit, pd->policy->id, msg->stat->num_points);
		}



}

//////////////////////////////////////////////////////////////////////////
void my_stStatSql_p(stat_data *s, char prefix, MYSQL *m, int i, oid u, oid p, unsigned points){
	char *query;
	query=(char *)aMalloc(255);
	MYSQL_RES *res;
	MYSQL_ROW row;
	pstat tmp;
	unsigned j;
	time_t a,b;

	b=time(NULL);
	a=time(NULL)-points*60*60-60*55;

	for (j=0; j<points; j++) {
		s->in[i*points+j]=0;
		s->out[i*points+j]=0;
		}

	snprintf(query, 254, "SELECT DISTINCT t_from, bytes_in, bytes_out FROM summary WHERE prefix='H' AND unit_oid=%d AND policy_oid=%d AND t_from>(UNIX_TIMESTAMP()-%ld-60*59)", u, p, (long)points*60*60);

	mysql_query(m, query);
	res=mysql_store_result(m); 
	if (res) {
		while ((row=mysql_fetch_row(res))) {
			sscanf(row[0], "%lu", &tmp.from); 
			sscanf(row[1], "%qu", &tmp.in);
			sscanf(row[2], "%qu", &tmp.out);
			j=(unsigned)((points)*(double)(tmp.from-a)/(b-a));
//			printf("j=%u ", j);
			s->in[i*points+j]=tmp.in;
			s->out[i*points+j]=tmp.out;
			}
		mysql_free_result(res);
		}
	aDebug(DEBUG_STORAGE, "SQL<-HDD/%c pd=%d query STAT %d bytes\n%s\n", prefix, i, strlen(query), query);

	aFree(query);
	}

//////////////////////////////////////////////////////////////////////////
unsigned my_stSyncSql(Service *s){
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

	 if(mysql_ping((MYSQL*)cfg->fd1) || mysql_ping((MYSQL*)cfg->fd2)) 
		return 0;

	return 1;
}

//////////////////////////////////////////////////////////////////////////
void my_stMonitorToSql(Service *s, time_t t, unsigned msec, NetUnit *u, struct ip *ip){
	
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;

	char *query;
	query=(char *)aMalloc(255);
	int i;
	struct tcphdr *th;
	th=(struct tcphdr *)((unsigned char *)ip + ip->ip_hl*4);

	snprintf(query, 254, "INSERT DELAYED INTO monitor VALUES (FROM_UNIXTIME(%ld), %u, '%s', %u, %u, %lu, %u, %lu, %u, %u)", t, msec, u->name?u->name:"<??>", u->id, ip->ip_p, ntohl(ip->ip_src.s_addr), ntohs(th->th_sport), ntohl(ip->ip_dst.s_addr), ntohs(th->th_dport), ntohs(ip->ip_len));
	mysql_query((MYSQL*)cfg->fd3, query);
	i=mysql_affected_rows((MYSQL*)cfg->fd3);
//	aDebug(DEBUG_STORAGE, "%d %s\n", i, query); 
	aDebug(DEBUG_STORAGE, "SQL->HDD/monitor query %d bytes, affected: %d\n", strlen(query), i);

	aFree(query);

}

#endif
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
