/*************************************************************************
***     Authentication, authorization, accounting + firewalling package
***     (c) 1998-2003 Anton Vinokurov <anton@netams.com>
***		(c) 2003 NeTAMS Development Team
***		All rights reserved. See 'Copying' file included in distribution
***		For latest version and more info, visit this project web page
***		located at http://www.netams.com
***		 					
*************************************************************************/
/* $Id: st_sql_postgres.c,v 1.11 2003/04/24 14:39:35 jura Exp $ */

#ifdef USE_POSTGRES

#include "netams.h"

//////////////////////////////////////////////////////////////////////////
void pg_stOpenSql(Service *s){

	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
//	FILE *debug;
	PGresult  *res;
	PGconn *conn1=NULL;
        PGconn *conn2=NULL;	
	PGconn *conn3=NULL;

	char *pg_host, *pg_user, *pg_pass, *pg_dbname;
	char buffer[255]; 
        
	if (!cfg->hostname) pg_host="localhost"; else pg_host=cfg->hostname;
        if (!cfg->username) pg_user="root"; else pg_user=cfg->username;
        if (!cfg->password) pg_pass=""; else pg_pass=cfg->password;
        if (!cfg->dbname) pg_dbname="netams"; else pg_dbname=cfg->dbname;

	
	conn1 = PQsetdbLogin(pg_host,NULL,NULL,NULL,pg_dbname,pg_user,pg_pass);
	if (PQstatus(conn1) == CONNECTION_BAD) {
		PQfinish(conn1);
		conn1 = PQsetdbLogin(pg_host,NULL,NULL,NULL,"template1",pg_user,pg_pass);
		if (PQstatus(conn1) == CONNECTION_BAD) {	
             		aLog(D_WARN, "postgres connect failed: %s, continuing closed\n",  PQerrorMessage(conn1));
			return;
		}
		PQexec(conn1,"SET autocommit TO 'on'"); PQclear(res);

		sprintf(buffer,"SELECT * FROM pg_database WHERE datname='%s'",pg_dbname);
		res = PQexec(conn1, buffer);
        	if (PQresultStatus(res) != PGRES_TUPLES_OK) {
			aLog(D_ERR, "postgres list dbs failed: %s\n", PQerrorMessage(conn1));
			return;
		}
		if(!PQntuples(res)) { //hmmm, there are no netams database there... creating everything...
			PQclear(res);
			snprintf(buffer, 254, "CREATE DATABASE %s", pg_dbname);
			res = PQexec(conn1, buffer);
			if (PQresultStatus(res) != PGRES_COMMAND_OK) {
				aLog(D_ERR, "postgres create db failed: %s\n",PQerrorMessage(conn1));
				return;
			}
			PQclear(res);
			PQfinish(conn1);

			conn1 = PQsetdbLogin(pg_host,NULL,NULL,NULL,pg_dbname,pg_user,pg_pass);
			if (PQstatus(conn1) == CONNECTION_BAD) {
                        	aLog(D_WARN, "postgres connect failed: %s, continuing closed\n",  PQerrorMessage(conn1));
                        	return;
                	}
			res = PQexec(conn1,"BEGIN"); PQclear(res);
			res = PQexec(conn1,"CREATE TABLE raw (unit_oid INT NOT NULL, policy_oid INT NOT NULL, t_from INT , t_to INT , bytes_in BIGINT , bytes_out BIGINT ,id BIGSERIAL PRIMARY KEY, hostname VARCHAR(32) NULL)");
			if (PQresultStatus(res) != PGRES_COMMAND_OK) {
 				aLog(D_ERR, "postgres create raw failed: %s\n", PQerrorMessage(conn1));
				return;
			}
			PQclear(res);
			res = PQexec(conn1,"CREATE INDEX raw_unit_oid_idx ON raw(unit_oid)"); PQclear(res);
                        res = PQexec(conn1,"CREATE INDEX raw_policy_oid_idx ON raw(policy_oid)"); PQclear(res);
			
			res = PQexec(conn1,"CREATE TABLE summary (prefix CHAR(1) NOT NULL, unit_oid INT NOT NULL, policy_oid INT NOT NULL, t_from INT NOT NULL, bytes_in BIGINT, bytes_out BIGINT)");
			if (PQresultStatus(res) != PGRES_COMMAND_OK) {	
				aLog(D_ERR, "postgres create summary failed: %s\n", PQerrorMessage(conn1));
				return;
			}
			PQclear(res);
                        res = PQexec(conn1,"CREATE INDEX summary_unit_oid_idx ON summary(unit_oid)"); PQclear(res);
                        res = PQexec(conn1,"CREATE INDEX summary_policy_oid_idx ON summary(policy_oid)"); PQclear(res);
                        res = PQexec(conn1,"CREATE INDEX summary_t_from_idx ON summary(t_from)"); PQclear(res);
			
			res = PQexec(conn1,"CREATE TABLE monitor (time INT NOT NULL , msec SMALLINT , name VARCHAR(32), unit_oid INT , proto SMALLINT , src BIGINT NOT NULL, srcport INT , dst BIGINT NOT NULL, dstport INT , len INT)");
			if (PQresultStatus(res) != PGRES_COMMAND_OK) { 
				aLog(D_ERR, "postgres create monitor failed: %s\n", PQerrorMessage(conn1));
				return;
			}
			PQclear(res);
			res = PQexec(conn1,"CREATE INDEX monitor_unit_oid_idx ON monitor(unit_oid)"); 
			res = PQexec(conn1,"END");
			aLog(D_WARN, "postgres database [%s] created\n", pg_dbname);
		}
		PQclear(res);
		
	}

	conn2 = PQsetdbLogin(pg_host,NULL,NULL,NULL,pg_dbname,pg_user,pg_pass);
	if (PQstatus(conn2) == CONNECTION_BAD) {
               aLog(D_WARN, "postgres connect failed: %s, continuing closed\n",  PQerrorMessage(conn2));
        	return;
	}

//if we monitor to database open connection for it
	Service *ss=NULL;
        while((ss=Services.getServiceByName("monitor",ss))) {
                Monitor_cfg *Monitor=(Monitor_cfg*)ss->cfg;

		if(Monitor->storage_s == s) {
        		conn3 = PQsetdbLogin(pg_host,NULL,NULL,NULL,pg_dbname,pg_user,pg_pass);
        		if (PQstatus(conn3) == CONNECTION_BAD) {
               			aLog(D_WARN, "postgres connect failed: %s, continuing closed\n",PQerrorMessage(conn3));
        			return;
			}
			(PGconn*)cfg->fd3=conn3;
			res=PQexec(conn3,"BEGIN");PQclear(res);
			break;
		}
	}
	(PGconn*)cfg->fd1=conn1;
	(PGconn*)cfg->fd2=conn2;

//	debug = fopen("/tmp/trace.out","a"); 
//     PQtrace(conn1, debug);  
//     PQtrace(conn3,debug);

	aLog(D_INFO, "POSTGRESQL DB:%d opened [%s]\n", s->instance, pg_dbname);

	res=PQexec(conn1,"BEGIN");PQclear(res);
        res=PQexec(conn2,"BEGIN");PQclear(res);


}

//////////////////////////////////////////////////////////////////////////
void pg_stCloseSql(Service *s){

	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	PGresult *res;
        PGconn *conn1=(PGconn*)cfg->fd1;
        PGconn *conn2=(PGconn*)cfg->fd2;
        PGconn *conn3=(PGconn*)cfg->fd3;

	
	if (PQstatus(conn1) == CONNECTION_OK) {
		res=PQexec(conn1,"END");
		PQclear(res);
	}
	
	if (PQstatus(conn2) == CONNECTION_OK) {
                res=PQexec(conn2,"END");
                PQclear(res);
        }


	if(PQstatus(conn3) == CONNECTION_OK) {
		res=PQexec(conn3,"END");
		PQclear(res);
	}
	PQfinish(conn1);
	PQfinish(conn2);
	PQfinish(conn3);	
	
	aLog(D_INFO, "POSTGRESQL DB:%d closed\n", s->instance);

}

//////////////////////////////////////////////////////////////////////////
void pg_stSaveSql(Service *s, Message *msg){

	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	
	PGresult  *res;
        PGconn *conn1=(PGconn*)cfg->fd1;
        PGconn *conn2=(PGconn*)cfg->fd2;

	char *query;
	query=(char *)aMalloc(255);
	char *i;
	NetUnit *u;

	if(!cfg->in->num_items) {
                res=PQexec(conn1,"COMMIT"); PQclear(res);
                res=PQexec(conn1,"BEGIN"); PQclear(res);
		res=PQexec(conn2,"COMMIT"); PQclear(res);
                res=PQexec(conn2,"BEGIN"); PQclear(res);
        }


	switch (msg->prefix){
		case 'F':
			u=Units.getUnitById(msg->netunit);
			snprintf(query, 254, "INSERT INTO raw VALUES (%d, %d, %ld, %ld, %qu, %qu,nextval('raw_id_seq') , '%s')", msg->netunit, msg->ap, msg->data.from, msg->data.to, msg->data.in, msg->data.out, u->name?u->name:"<??>");
			
			res = PQexec(conn1,query); //stay silent if something wrong
			i=PQcmdTuples(res);
			PQclear(res);
			// aDebug(DEBUG_STORAGE, "%s %s\n", i, query); 
			aDebug(DEBUG_STORAGE, "SQL->HDD/raw(F) query %d bytes, affected: %s\n", strlen(query), i);
			break;

		case 'T':
		case 'M':
		case 'W':
		case 'D':
		case 'H':
			snprintf(query, 254, "UPDATE summary SET bytes_in=%qu, bytes_out=%qu WHERE (prefix='%c' AND unit_oid=%d AND policy_oid=%d AND t_from=%ld)", msg->data.in, msg->data.out, msg->prefix, msg->netunit, msg->ap, msg->data.from);
			res = PQexec(conn2,query); //stay silent if something wrong
                        i=PQcmdTuples(res);
                        PQclear(res);
			
			// aDebug(DEBUG_STORAGE, "%d %s\n", i, query); 
			if (!strcmp(i,"0")) { // update failed!
				snprintf(query, 254, "INSERT INTO summary VALUES ('%c', %d, %d, %ld, %qu, %qu)", msg->prefix, msg->netunit, msg->ap, msg->data.from, msg->data.in, msg->data.out);
				res = PQexec(conn2,query);
				i=PQcmdTuples(res);
				PQclear(res);
				// aDebug(DEBUG_STORAGE, "%s %s\n", i, query); 
			}
			aDebug(DEBUG_STORAGE, "SQL->HDD/summary(%c) query %d bytes, affected: %s\n", msg->prefix, strlen(query), i);
			break;
		}

	aFree(query);

}
//////////////////////////////////////////////////////////////////////////
void pg_stLoadSql(Service *s, Message *msg){

	msg->id=s->instance;
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	PGresult  *res;
        PGconn *conn1=(PGconn*)cfg->fd1;
        PGconn *conn2=(PGconn*)cfg->fd2;
	PGconn *conn;
	
	char *query;
	query=(char *)aMalloc(255);
	
	pstat *cps;
	
	if (msg->pdata)  // assuming type is READ, fill this unit policy data field on policy apply (startup)
		switch (msg->prefix){
			case 'T': cps=&(msg->pdata->t); break;
			case 'M': cps=&(msg->pdata->m); break;
			case 'W': cps=&(msg->pdata->w); break;
			case 'D': cps=&(msg->pdata->d); break;
			case 'H': cps=&(msg->pdata->h); break;
			case 'F': cps=&(msg->pdata->flow); break;
			}
	else cps=&(msg->data);	// pdata is NULL, reading a raw data while program is running

	if (msg->prefix=='F') {
			snprintf(query, 254, "SELECT bytes_in, bytes_out FROM raw WHERE unit_oid=%d AND policy_oid=%d AND t_from=%ld AND t_to=%ld", msg->netunit, msg->ap, cps->from, cps->to);
			conn=conn1;
		} else if (msg->prefix=='T') {
			snprintf(query, 254, "SELECT bytes_in, bytes_out, t_from FROM summary WHERE prefix='T' AND unit_oid=%d AND policy_oid=%d", msg->netunit, msg->ap);
			conn=conn2;
		} else {
			snprintf(query, 254, "SELECT bytes_in, bytes_out FROM summary WHERE prefix='%c' AND unit_oid=%d AND policy_oid=%d AND t_from=%ld", msg->prefix, msg->netunit, msg->ap, cps->from);
			conn=conn2;
		}
	
	res=PQexec(conn,query);
	if(PQresultStatus(res) == PGRES_TUPLES_OK) {
		if(PQntuples(res)) {		
			sscanf(PQgetvalue(res,0,0), "%qu", &cps->in); 
			sscanf(PQgetvalue(res,0,1), "%qu", &cps->out);
			if (msg->prefix=='T') sscanf(PQgetvalue(res,0,2), "%ld", &cps->from);
		}
	}
	PQclear(res);
	aDebug(DEBUG_STORAGE, "SQL<-HDD/%c query %d bytes, fr=%ld in=%qu out=%qu\n", msg->prefix, strlen(query), cps->from, cps->in, cps->out);

	aFree(query);
}

//////////////////////////////////////////////////////////////////////////
void pg_stStatSql(Service *s, Message *msg){
	msg->id=s->instance;
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	PGconn *conn=(PGconn*)cfg->fd2;

	policy_data *pd;
	NetUnit *u;
	int i;

	u=Units.getUnitById(msg->netunit);
	if (!u) return;

	msg->stat->num_policies=u->ap.num_policies;

	switch (msg->prefix){
		case 'W':
			msg->stat->num_points=24*7;
			break;
		case 'M':
			msg->stat->num_points=24*31;
			break;
		default:
			return;
		}

	msg->stat->in =(unsigned long long*)aMalloc((sizeof (unsigned long long))*msg->stat->num_points*msg->stat->num_policies);
	msg->stat->out=(unsigned long long*)aMalloc((sizeof (unsigned long long))*msg->stat->num_points*msg->stat->num_policies);
		
				
	for (pd=u->ap.root, i=0; pd!=NULL; pd=pd->next, i++) {
		pg_stStatSql_p(msg->stat, msg->prefix, conn, i, msg->netunit, pd->policy->id, msg->stat->num_points);
		}
}

//////////////////////////////////////////////////////////////////////////
void pg_stStatSql_p(stat_data *s, char prefix, PGconn *conn, int i, oid u, oid p, unsigned points){
	char *query;
	query=(char *)aMalloc(255);
	PGresult *res;
	
	int row;	
	
	pstat tmp;
	unsigned j;
	time_t a,b;

	b=time(NULL);
	a=time(NULL)-points*60*60-60*55;

	for (j=0; j<points; j++) {
		s->in[i*points+j]=0;
		s->out[i*points+j]=0;
		}

	snprintf(query, 254, "SELECT DISTINCT t_from, bytes_in, bytes_out FROM summary WHERE prefix='H' AND unit_oid=%d AND policy_oid=%d AND t_from>(UNIX_TIMESTAMP()-%ld-60*59)", u, p, (long)points*60*60);

	res=PQexec(conn, query);
        if(PQresultStatus(res) == PGRES_TUPLES_OK) {
                for(row=0;row < PQntuples(res); row++) {
                        sscanf(PQgetvalue(res,row,0), "%lu", &tmp.from);
                        sscanf(PQgetvalue(res,row,1), "%qu", &tmp.in);
                        sscanf(PQgetvalue(res,row,2), "%qu", &tmp.out);
                        j=(unsigned)((points)*(double)(tmp.from-a)/(b-a));
//                      printf("j=%u ", j);
                        s->in[i*points+j]=tmp.in;
                        s->out[i*points+j]=tmp.out;
		}
        }
        PQclear(res);

	aDebug(DEBUG_STORAGE, "SQL<-HDD/%c pd=%d query STAT %d bytes\n%s\n", prefix, i, strlen(query), query);

	aFree(query);
	}

//////////////////////////////////////////////////////////////////////////
unsigned pg_stSyncSql(Service *s){
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	PGconn *conn1=(PGconn*)cfg->fd1;
	PGconn *conn2=(PGconn*)cfg->fd2;
	PGconn *conn3=(PGconn*)cfg->fd3;

	 if(PQstatus(conn1) == CONNECTION_BAD || PQstatus(conn2) == CONNECTION_BAD ) {
		pg_stCloseSql(s);
		return 0;
	}

	return 1;
}

//////////////////////////////////////////////////////////////////////////
void pg_stMonitorToSql(Service *s, time_t t, unsigned msec, NetUnit *u, struct ip *ip){
	
	ServiceStorage_cfg *cfg=(ServiceStorage_cfg *)s->cfg;
	PGconn *conn=(PGconn*)cfg->fd3;
	PGresult *res;
	char *query;
	char *i;
	struct tcphdr *th;
	
	query=(char *)aMalloc(255);
	th=(struct tcphdr *)((unsigned char *)ip + ip->ip_hl*4);

	snprintf(query, 254, "INSERT INTO monitor VALUES (%ld, %u, '%s', %u, %u, %lu, %u, %lu, %u, %u)", t, msec, u->name?u->name:"<??>", u->id, ip->ip_p, ntohl(ip->ip_src.s_addr), ntohs(th->th_sport), ntohl(ip->ip_dst.s_addr), ntohs(th->th_dport), ntohs(ip->ip_len));
	res = PQexec(conn,query);
	i=PQcmdTuples(res);
        PQclear(res);
	Monitor_cfg *Monitor=(Monitor_cfg*)u->monitor;
	if(Monitor->commit_num++ == MONITOR_COMMIT_NUM ) {
		res=PQexec(conn,"COMMIT"); PQclear(res);
		res=PQexec(conn,"BEGIN"); PQclear(res);
		Monitor->commit_num=0;
	}
//	aDebug(DEBUG_STORAGE, "%s %s\n", i, query); 
	aDebug(DEBUG_STORAGE, "SQL->HDD/monitor query %d bytes, affected: %s\n", strlen(query), i);

	aFree(query);

}

#endif
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
